typedef unsigned long dword;
#define BIT_BANK_SIZE 63

//!  
class BitStack{
	struct bank_st{
		dword map[BIT_BANK_SIZE];
		bank_st *prev;
	}*list;
	int index;
	void NewBank();
public:
	BitStack();
	~BitStack();
	void Clear();		//!<  
	void Push(bool);	//!<  
	bool Pop();			//!<  
};

BitStack::BitStack()
{
	list=0;
	index=BIT_BANK_SIZE*32;
}


BitStack::~BitStack()
{
	Clear();
}


void BitStack::Clear()
{
	while(list) {
		bank_st *prev=list->prev;
		delete list;
		list=prev;
	}
}

void BitStack::Push(bool bit)
{
	if(index>=BIT_BANK_SIZE*32) NewBank();
	if(bit) list->map[index/32]|=1<<(index&31);
	else list->map[index/32]&=~(1<<(index&31));
	index++;
}

//! \result true   
bool BitStack::Pop()
{
	bool res;
	if(!list) return true;
	index--;
	res=!!(list->map[index/32]&(1<<(index&31)));
	if(!index) {
		bank_st *prev=list->prev;
		delete list;
		list=prev;
		index=BIT_BANK_SIZE*32;
	}
	return res;
}

void BitStack::NewBank()
{
	bank_st *temp=new bank_st;
//	memset(temp,0,sizeof(temp));
	temp->prev=list;
	list=temp;
	index=0;
}



